<?php
  
namespace MyApp\MyBundle\API\Repository\Values\Content\Query\Criterion;
  
use eZ\Publish\API\Repository\Values\Content\Query\Criterion;
use eZ\Publish\API\Repository\Values\Content\Query\Criterion\Operator\Specifications;
use eZ\Publish\API\Repository\Values\Content\Query\CriterionInterface;
  
/**
 * A criterion that matches content based on its tags id
 */
class TagId extends Criterion implements CriterionInterface
{
    public function __construct( $value )
    {
        parent::__construct( null, null, $value );
    }
  
    public function getSpecifications()
    {
        return array(
            new Specifications(
                Criterion\Operator::IN,
                Specifications::FORMAT_ARRAY,
                Specifications::TYPE_INTEGER | Specifications::TYPE_STRING
            ),
            new Specifications(
                Criterion\Operator::EQ,
                Specifications::FORMAT_SINGLE,
                Specifications::TYPE_INTEGER | Specifications::TYPE_STRING
            ),
        );
    }
  
    public static function createFromQueryBuilder( $target, $operator, $value )
    {
        return new self( $value );
    }
}
